/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#ifndef BOMB_H
#define BOMB_H
#include <cassert>
#include <ncurses.h>
#include <cstdlib>
#include <ctime>
#include "Maze.h"
class Bomb
{
	protected:
		unsigned power;
		int timeForExplosion;
		int timeDropped;//da inizializzare
		bool available;
		bool dropped;
		unsigned originX,originY;
		int animation;
		

	public:
		Bomb (unsigned pow=3,int time=5,bool available=true,bool dropped=false,int originX=0,int originY=0);
		void setAvailability(bool);
		void setPower(unsigned);
		void setTime(int);//da implementare
		void setDrop(bool);
		void setTimeDropped(int);

		bool getAvailability()const;
		unsigned getPower()const;
		int getTime()const;
		bool isDropped()const;
		void deleteIfPossible(int l,int c,const char symb)const;
		
		virtual void explode(int l,int c,int time,char but);


};
#endif
