/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#ifndef BOMBERTUX_H
#define BOMBERTUX_H
#include "Bomb.h"
#include <ncurses.h>
#include <vector>

class Bombertux
{
	friend class Bomb;
	private:
		static bool dead;
		int life;
		vector<Bomb*>bombs;
		int usingBomb;
		bool twoBombs;
		
		
	public:
		Bombertux(int life=3);

		int getLife()const;
		static bool isDead();
		const vector<Bomb*>& getBombs()const;

		void setLife(int life);
		void getPowerUp(int,int,int&);
		void moveTux(int&,int&,int&,int&,int&,int&,int,int&);
		static void setDeath(bool);
		void setPosition(const char);
		void addBomb(Bomb&);
		void checkLife(int,int);
		void deathAnimation(int,int,int,int,int,int);
		void timeToPoints();
		bool canDropTwoBombs()const;
		bool hasThisBomb(int bomb)const;
		
		
		
		



};
#endif
