/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "Boss.h"
#include <panel.h>

Boss::Boss(string first, string second, string third, string forth, string fifth, string sixth, string seventh,
           int velo,int nol,int y,int x)
		 	:Monster(first,velo,nol,y,x),segmentationFault("<-<-<-<-"),doubleFree("        ")
	{
		secondComposition=second;
		thirdComposition=third;
		fourthComposition=forth;
		fifthComposition=fifth;
		sixthComposition=sixth;
		seventhComposition=seventh;
		
	}

int Boss::life=20;

void Boss::draw()
{
	attron(COLOR_PAIR(1));
	mvprintw(originY,originX,baseComposition.data());
	mvprintw(originY+1,originX,secondComposition.data());
	mvprintw(originY+2,originX,thirdComposition.data());
	mvprintw(originY+3,originX,fourthComposition.data());
	mvprintw(originY+4,originX,fifthComposition.data());
	mvprintw(originY+5,originX,sixthComposition.data());
	mvprintw(originY+6,originX,seventhComposition.data());
	refresh();

	for(int i=0;i<7;i++)
		for(int j=0;j<baseComposition.length();j++)
			Maze::control [originY+i][originX+j]='X';
	
}

void Boss::moveMonster()
{
	//0-> giu, 1->su
    int move=rand()%2;
	attron(COLOR_PAIR(1));
	switch(move)
    {
		case 0:
			if(Maze::isFreeSpaceForBoss(originY+1,originX,numberOfLines,baseComposition.length() ) )
			{
				mvprintw(originY,originX,"		                                      ");
				mvprintw(originY+1,originX,"		                                      ");
				mvprintw(originY+2,originX,"		                                      ");
				mvprintw(originY+3,originX,"		                                      ");
				mvprintw(originY+4,originX,"		                                      ");
				mvprintw(originY+5,originX,"		                                      ");
				mvprintw(originY+6,originX,"		                                      ");
		
				mvprintw(originY+1,originX,baseComposition.data());
				mvprintw(originY+2,originX,secondComposition.data());
				mvprintw(originY+3,originX,thirdComposition.data());
				mvprintw(originY+4,originX,fourthComposition.data());
				mvprintw(originY+5,originX,fifthComposition.data());
				mvprintw(originY+6,originX,sixthComposition.data());
				mvprintw(originY+7,originX,seventhComposition.data());
				
					
				for(int i=0;i<baseComposition.length();i++)
				{
					Maze::control [originY+7][originX+i]='X';
					Maze::control [originY] [originX+i]='L';
				}
				originY+=1;

			}
			break;
		case 1:
			if(Maze::isFreeSpaceForBoss(originY-1,originX,numberOfLines,baseComposition.length()) )
			{
				mvprintw(originY,originX,"		                                      ");
				mvprintw(originY+1,originX,"		                                      ");
				mvprintw(originY+2,originX,"		                                      ");
				mvprintw(originY+3,originX,"		                                      ");
				mvprintw(originY+4,originX,"		                                      ");
				mvprintw(originY+5,originX,"		                                      ");
				mvprintw(originY+6,originX,"		                                      ");

				mvprintw(originY-1,originX,baseComposition.data());
				mvprintw(originY,originX,secondComposition.data());
				mvprintw(originY+1,originX,thirdComposition.data());
				mvprintw(originY+2,originX,fourthComposition.data());
				mvprintw(originY+3,originX,fifthComposition.data());
				mvprintw(originY+4,originX,sixthComposition.data());
				mvprintw(originY+5,originX,seventhComposition.data());
				
				
				for(int i=0;i<baseComposition.length();i++)
				{
					Maze::control [originY+6][originX+i]='L';
					Maze::control [originY-1] [originX+i]='X';
				}
				originY-=1;
			}
			break;
		}
		
			
			
    }
    
    

void Boss::killed()
{


}

bool Boss::checkLife()
{
	for(int i=originY;i<originY+numberOfLines;i++)
		for(int j=originX;j<originX+baseComposition.length();j++)
			if(Maze::control[i][j]==' ')
				return false;
	return true;
}

void Boss::shoot(int time)
{

	int skill=rand()%2;
	
	

	switch(skill)
	{
	case 0:	mvprintw(originY+3,originX-3,segmentationFault.data());
			currentAttack=segmentationFault;
			originShootY=originY+3;
			originShootX=originX-3;
			if(rand()%4==0)
			{
				WINDOW* skills=newwin (5,40,20,40);
				wbkgd(skills,COLOR_PAIR(2));
				box(skills,'*','*');
				mvwprintw(skills,1,1,"Malloc:\n ");
				PANEL* skillPanel=new_panel(skills);
				mvwprintw(skills,2,1,"Take this: SEGMENTATION FAULT!");
				update_panels();
				doupdate();
				usleep(1500000);
				del_panel(skillPanel);
				delwin(skills);
			}
			
				
				
			shooted=true;
			break;

	case 1: 
			attron(COLOR_PAIR(8));
			mvprintw(originY,originX-3,doubleFree.data());  
			mvprintw(originY+6,originX-3,doubleFree.data());
			currentAttack=doubleFree;
			originShootY=originY;
			originShootX=originX-3;
			if(rand()%4==0)
			{
				WINDOW* skills=newwin (5,40,20,40);
				wbkgd(skills,COLOR_PAIR(2));
				box(skills,'*','*');
				mvwprintw(skills,1,1,"Malloc:\n ");
				PANEL* skillPanel=new_panel(skills);
				mvwprintw(skills,2,1," Did you forget the copy constructor?\n DOUBLE FREE!");
				update_panels();
				doupdate();
				usleep(1500000);
				del_panel(skillPanel);
				delwin(skills);
			}
			shooted=true;
			break;

	
	}

			
			
		
}

void Boss::moveShoot()
{
	
	if(currentAttack == doubleFree)
	{
		if(Maze::control[originShootY][originShootX-1]!='M'&& Maze::control[originShootY+6][originShootX-1]!='M')
		{
			attron(COLOR_PAIR(7));
			mvprintw(originShootY,originShootX,"        ");
			mvprintw(originShootY+6,originShootX,"        ");
			for(int i=0;i<8;i++)
			{

				Maze::control[originShootY][originShootX+i]='L';
				Maze::control[originShootY+6][originShootX+i]='L';
					
			}
			attron(COLOR_PAIR(8));
			mvprintw(originShootY,originShootX-1,currentAttack.data());
			mvprintw(originShootY+6,originShootX-1,currentAttack.data());
			originShootX--;
			for(int i=0;i<8;i++)
			{
				Maze::control[originShootY][originShootX+i]='X';
				Maze::control[originShootY+6][originShootX+i]='X';
			}
		}
		else
		{
			attron(COLOR_PAIR(7));
			mvprintw(originShootY,originShootX,"        ");
			mvprintw(originShootY+6,originShootX,"        ");
			shooted=false;
			for(int i=0;i<8;i++)
			{
				Maze::control[originShootY][originShootX+i]='L';
				Maze::control[originShootY+6][originShootX+i]='L';
			}	
		}
	}
		

	else
	{

	if(Maze::control[originShootY][originShootX-1]!='M')
	{
		attron(COLOR_PAIR(7));
		
		
		mvprintw(originShootY,originShootX,"        ");

		for(int i=0;i<8;i++)
			Maze::control[originShootY][originShootX+i]='L';


		attron(COLOR_PAIR(13));
		mvprintw(originShootY,originShootX-1,currentAttack.data());
		originShootX--;
		refresh();
		for(int i=0;i<8;i++)
		Maze::control[originShootY][originShootX+i]='X';
		
	}
	else
	{
	shooted=false;
	attron(COLOR_PAIR(7));
	mvprintw(originShootY,originShootX,"        ");
	for(int i=0;i<8;i++)
		Maze::control[originShootY][originShootX+i]='L';
	refresh();
		
	}
	}
}

const string& Boss::getCurrentAttack()const
{
	return currentAttack;
}

void Boss::reDraw()
{
	attron(COLOR_PAIR(1));
	mvprintw(originY,originX,baseComposition.data());
	mvprintw(originY+1,originX,secondComposition.data());
	mvprintw(originY+2,originX,thirdComposition.data());
	mvprintw(originY+3,originX,fourthComposition.data());
	mvprintw(originY+4,originX,fifthComposition.data());
	mvprintw(originY+5,originX,sixthComposition.data());
	mvprintw(originY+6,originX,seventhComposition.data());

	for(int i=originY;i<originY+numberOfLines;i++)
		for(int j=originX;j<originX+baseComposition.length();j++)
			Maze::control[i][j]='X';
	
	
}
int Boss::getLife()
{
	return life;
}
void Boss::decrementLife()
{
	life--;
}
void Boss::delShoot()
{
	attron(COLOR_PAIR(7));
	if(currentAttack == doubleFree)
	{
		mvprintw(originShootY,originShootX,"        ");
			mvprintw(originShootY+6,originShootX,"        ");
			for(int i=0;i<8;i++)
			{
				Maze::control[originShootY][originShootX+i]='L';
				Maze::control[originShootY+6][originShootX+i]='L';
			}
	}
	else
	{
		mvprintw(originShootY,originShootX,"        ");
		for(int i=0;i<8;i++)
			Maze::control[originShootY][originShootX+i]='L';
	}
	shooted=false;
	
}

