/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#ifndef BOSS_H
#define BOSS_H
#include "Monster.h"
#include <string.h>
#include "Stats.h"
class Boss : public Monster
{
	friend class Stats;
	private:
		static int life;
		string secondComposition;
		string thirdComposition;
		string fourthComposition;
		string fifthComposition;
		string sixthComposition;
		string seventhComposition;

		string segmentationFault;
		string doubleFree;
		string badAlloc;
		string bufferOverflow;

		string currentAttack;
	public:
		Boss(string first="                   ____________                    ",string sec="        __________|  \\      /  |__________        ",
			 string third="      /   ______  |  O      O  | ______    \\      ",
			 string fort="     /   /        |   /\\/\\/\\   |        \\   \\ ",string fif="    /   /         |   \\/\\/\\/   |         \\   \\",
			 string six="   /   /          |____________|          \\   \\  ",string sev="  /__ /                                    \\___\\ ",
			 int velocity=2,int nol=7,int y=15,int x=48);


		
		virtual void draw();
		virtual void moveMonster();
		virtual void killed();
		virtual bool checkLife();
		virtual void shoot(int);
		virtual void moveShoot();

		static int getLife();
		

		void delShoot();
		void reDraw();
		const string& getCurrentAttack()const;

		static void decrementLife();
};
#endif
