/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "Maze.h"
#include <panel.h>
#include "Monster.h"

char Maze::control[30][100];

void Maze::beginControl()
{	
	for(int i=0;i<100;i++)
		for(int j=0;j<30;j++)
			Maze::control[j][i]='L';

	for(int c=0;c<100;c++)
		for(int l=0;l<Maze::beginOfMaze;l++)
			Maze::control[l][c]='M';

	for(int i=0;i<100;i++)
 		{
			Maze::control[0][i]='M';
			Maze::control[29][i]='M';
		}		
	for(int i=0;i<30;i++)
		{
			Maze::control[i][0]='M';
			Maze::control[i][99]='M';
		}	
		
}

void Maze::drawForBoss()
{
	attron(COLOR_PAIR(2));
	Block notFriable;
	notFriable.drawBlock(13,15);
	notFriable.drawBlock(25,15);
	for(int i=0;i<4;i++)
	{
		Maze::control[13][15+i]='M';
		Maze::control[14][15+i]='M';
	
		Maze::control[25][15+i]='M';
		Maze::control[26][15+i]='M';
	}
}

void Maze::draw ()
{
	box(stdscr,'X','X');
	bkgd(COLOR_PAIR(2));
	int c,l;//coordinate per i blocchi
	l=beginOfMaze;
	
	Block notFriable;
	Block friable("##",true);
	//metto i blocchi fissi
	
	attron (COLOR_PAIR(2));
	for(int i=0;i<3;i++)
	{
		c=15;
		for(int j=0;j<3;j++)
			{
				notFriable.drawBlock(l,c);
				Maze::setControl(l,c,notFriable);
					c+=35;
			}
				l+=7;
				
	}
	
	//metto i blocchi friabili
	//NOTA: fare funzione che completa la matrice di controllo se no è uno stress
	srand(time(0));
	attron(COLOR_PAIR(3));
	for(int l=Maze::beginOfMaze+4;l<30;l++)//+4 per far muovere tux
	
		for(int c=0;c<99;c++)
		{
			if(rand()%50==0)
				if(!(Maze::isThereABlock(l,c)))
				{
					friable.drawBlock(l,c);
					Maze::setControl(l,c,friable);
					c+=3;
					
				}
				
		}
	attron(COLOR_PAIR(1));
	
	
	
	
}


int Maze::isFreeForTux(int y,int x)
{
	for(int i=0;i<3;i++)
		for(int j=0;j<5;j++)
		{
			if(Maze::control[y+i][x+j]=='M' || Maze::control[y+i][x+j]=='B' || Maze::control[y+i][x+j]=='O' )
				return 0;
			if(Maze::control[y+i][x+j]=='X')
				return 2; //si può muovere ma morirà. E' essenziale xk altrimenti se incontra un mostro sovrascrive la X con la T e il check nn funziona
		}
	return 1;
			
}
bool Maze::isThereABlock(int y,int x)
{
	for(int l=y;l<y+2;l++)
		for(int c=x;c<x+4;c++)
			if(Maze::control[l][c]=='M')
				return true;
	return false;
}
void Maze::setControl(int l,int c,const Block& blk)
{
if(blk.friable==false)
	for(int k=0;k<4;k++)
		{
			Maze::control[l][c+k]='M';
			Maze::control[l+1][c+k]='M';
		}

else
	for(int k=0;k<2;k++)
	{
			Maze::control[l][c+k]='B';
			Maze::control[l+1][c+k]='B';
	}
}

int Maze::getBeginOfMaze()
{
	return beginOfMaze;
}

bool Maze::isFreeSpaceForMonster(int y,int x,int nol,int length)
{
	
		for(int l=y;l<y+nol;l++)
			for(int c=x;c<x+length;c++)
				if(Maze::control[l][c]!='L' && Maze::control[l][c]!='T') //&& Maze::control[l][c]!='X')
					return false;
	return true;
}
bool Maze::isFreeSpaceForBoss(int y,int x,int nol,int length)
{
	
		for(int l=y;l<y+nol;l++)
			for(int c=x;c<x+length;c++)
				if(Maze::control[l][c]!='L' && Maze::control[l][c]!='T' && Maze::control[l][c]!='X')
					return false;
	return true;
}
void Maze::delBlocks()
{
	mvprintw(13,15,"    ");
	mvprintw(14,15,"    ");
	mvprintw(25,15,"    ");
	mvprintw(26,15,"    ");

	for(int i=0;i<4;i++)
	{	
		Maze::control[13][15+i]='L';
		Maze::control[14][15+i]='L';
		Maze::control[25][15+i]='L';
		Maze::control[26][15+i]='L';
	}
}
