/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "Stats.h"
#include <cassert>
#include <ncurses.h>
#include <cstdlib> 
#include <panel.h>
#include "Boss.h"
Stats::Stats(int time,int points,int t,bool gameOver,bool boss)
:timeBuff(t),isThereABoss(boss)
{
	assert(gameOver==false);

	setTime(time);
	this->gameOver=gameOver;
}

int Stats::points=0;

int Stats::getTime()const
{
	return time;
}
int Stats::getPoints()
{
	return points;
}
bool Stats::isGameOver()
{
	return gameOver;
	
}

void Stats::setTime(int t)
{
	assert(t>50);
	time=t;
}
void Stats::setPoints(int p)
{
	assert(p>=0);
	points=p;
}

void Stats::view(const Bombertux& tux)
{
	attron(COLOR_PAIR(3));

	for(int i=0;i<100;i++)
	{
		mvprintw(0,0+i,"*");
		mvprintw(9,0+i,"*");
	}
	for(int i=0;i<10;i++)
	{
		mvprintw(i,0,"*");
		mvprintw(i,99,"*");
	}

	attron(COLOR_PAIR(15));
	//FINESTRA PUNTEGGI
	

	
	mvprintw(1,2,"TIME :");
	mvprintw(4,2,"POINTS :");
	mvprintw(7,2,"(| |) X");
	attron(COLOR_PAIR(1));
	if(time<100)
	{	
		attron(COLOR_PAIR(7));
		mvprintw(1,12," ");
	}
	if(time<10)
	{
		attron(COLOR_PAIR(7));
		mvprintw(1,11," ");
	}
	attron(COLOR_PAIR(1));
	mvprintw(1,10,"%d",time);
	mvprintw(4,10,"%d",points);
	mvprintw(7,10,"%d",tux.getLife());
	
	timeBuff--;
	if(timeBuff<=0)
	{
		timeBuff=45;
		time--;
	}
	if(time==0 || tux.getLife()==0)
		gameOver=true;
	
	//mvprintw(2,80,"%d",timeBuff);

	if(isThereABoss)
	{
		mvprintw(5,50,"MALLOC");
		attron(COLOR_PAIR(2));
		mvprintw(6,50,"-life-");
		
		for(int i=0;i<Boss::getLife();i++)
		{
			attron(COLOR_PAIR(14));
			mvprintw(7,50+i," ");
			attron(COLOR_PAIR(7));
			mvprintw(7,70-(20-Boss::getLife())," ");
		}
		
	}
	
	attron(COLOR_PAIR(15));
	mvprintw(1,20,"Second Bomb");
	if(tux.canDropTwoBombs())
	{
		attron(COLOR_PAIR(2));
		mvprintw(2,23,"ON");
		mvprintw(2,25," ");
		mvprintw(2,22," ");
		attron(COLOR_PAIR(7));
		mvprintw(2,26," ");
		
		
	}
	else
	{
		attron(COLOR_PAIR(1));
		mvprintw(2,23,"OFF");
		attron(COLOR_PAIR(4));
		mvprintw(2,26," ");
		mvprintw(2,22," ");
	}
	attron(COLOR_PAIR(15));
	mvprintw(4,20,"Blaster");
	if(tux.hasThisBomb(2))
	{
		attron(COLOR_PAIR(2));
		mvprintw(5,23,"ON");
		mvprintw(5,25," ");
		mvprintw(5,21," ");
		attron(COLOR_PAIR(7));
		mvprintw(5,26," ");
	}
	else
	{
		attron(COLOR_PAIR(1));
		mvprintw(5,23,"OFF");
		attron(COLOR_PAIR(4));
		mvprintw(5,26," ");
		mvprintw(5,22," ");
		
	}

	attron(COLOR_PAIR(15));
	mvprintw(2,50,"info -> falko91@aliceposta.it");
	
	
	
	
}

char Stats::weapons(const Bombertux& tux)
{
	WINDOW* weapon=newwin (15,40,10,10);
	init_pair(5,COLOR_YELLOW,COLOR_BLACK);
	attron(COLOR_PAIR(5));
	box(weapon,'$','$');
	mvwprintw(weapon,1,15,"WEAPONS");
	mvwprintw(weapon,2,1,"Normal Bomb (n)");
	if(tux.getBombs()[2]->getAvailability()==true)
		mvwprintw(weapon,3,1,"Bomb Blaster (b)");

    PANEL* stat=new_panel(weapon);
	update_panels();
	doupdate();
	char c;
	do
	c=getch();
	while(c==ERR);
	del_panel(stat);
	delwin(weapon);
	refresh();
	return c;
	
}

void Stats::timeToPoints(const Bombertux& tux)
{
	char c;
	do
	{
		usleep(20000);
		time--;
		points+=5;
		view(tux);
		refresh();
	}
	while(time > 0);
		
	
	
}
void Stats::setBoss(bool v)
{
	isThereABoss=v;
}

void Stats::pause()
{
	mvprintw(7,19,"--PAUSE--");
	refresh();
	char x;
	do
	{
		x=getch();
	}
	while (x!='p');
	attron(COLOR_PAIR(7));
	mvprintw(7,19,"         ");
	
	
		
	
}
