/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "StrongMonster.h"
#include "Maze.h"


StrongMonster::StrongMonster(const string& base,int vel,int numberOfLines,int x,int y,int pow,bool strng,bool shoot)
:CommonMonster(base,vel,numberOfLines,x,y,strng,shoot),power(pow)
{
	shooted=false;
}
void StrongMonster::shoot(int time)
{
	if(!shooted && isFreeToShoot())
	{
		mvprintw(originY,originX-4,"<---");
		Maze::control[originY][originX-4]='X';
		Maze::control[originY][originX-3]='X';
		Maze::control[originY][originX-2]='X';
		Maze::control[originY][originX-1]='X';
		shooted=true;
		originShootY=originY;
		originShootX=originX-4;
		timeOfShoot=time;
	}

}
bool StrongMonster::isFreeToShoot()
{
	for(int i=0;i<4;i++)
		if(Maze::control[originY][originX-i-1]=='M' || Maze::control[originY][originX-i-1]=='B')
			return false;
	return true;

	
}

void StrongMonster::killed()
{
	CommonMonster::killed();
	mvprintw(originShootY,originShootX,"    ");
		Maze::control[originShootY][originShootX]='L';
		Maze::control[originShootY][originShootX+1]='L';
		Maze::control[originShootY][originShootX+2]='L';
		Maze::control[originShootY][originShootX+3]='L';
		shooted=false;
}

void StrongMonster::moveShoot()
{
	attron(COLOR_PAIR(3));
	
	if(Maze::control[originShootY][originShootX-1]!='M' && Maze::control[originShootY][originShootX-1]!='B' && Maze::control[originShootY][originShootX-1]!='X')
	{
		
		mvprintw(originShootY,originShootX,"    ");
		Maze::control[originShootY][originShootX]='L';
		Maze::control[originShootY][originShootX+1]='L';
		Maze::control[originShootY][originShootX+2]='L';
		Maze::control[originShootY][originShootX+3]='L';
		mvprintw(originShootY,originShootX-1,"<---");
		originShootX--;
		refresh();
		Maze::control[originShootY][originShootX]='X';
		Maze::control[originShootY][originShootX+1]='X';
		Maze::control[originShootY][originShootX+2]='X';
		Maze::control[originShootY][originShootX+3]='X';
	}
	else
	{
		shooted=false;
		mvprintw(originShootY,originShootX,"    ");
		Maze::control[originShootY][originShootX]='L';
		Maze::control[originShootY][originShootX+1]='L';
		Maze::control[originShootY][originShootX+2]='L';
		Maze::control[originShootY][originShootX+3]='L';
	}
	attron(COLOR_PAIR(1));
}
