/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include <iostream>
#include <fstream>
#include "Block.h"
#include "Maze.h"
#include "Bombertux.h"
#include <ncurses.h>
#include "Stats.h"
#include <panel.h>
#include "StrongMonster.h"
#include "Boss.h"
#include "BombBlaster.h"
#include <list>


int welcome ();
void endOfGame();
void firstLevel(int&,int&,int&,int&,int&,int&);
void secondLevel(int&,int&,int&,int&,int&,int&);
void finalLevel (int&,int&,int&,int&,int&,int&);
void dialogue();
void story();
void howTo();
void difficulty();
void finalPart();
void scores(Stats);
void viewScores();
void beginScores();

struct gamer
{
	int points;
	char name[31];
};





int tempoAttuale;//serve per le animazioni e per lo scoppio della bomba
int currLife;//serve a capire quante vite ha ancora e se ne ha di meno di prima ricomincia il livello
bool win=false;//mi dice se ha finito il livello
int diff=0;
Bombertux tux;
Stats stat;
	

int main()
//MURO M, MURO CHE SI ROMPE B, PERSONAGGIO T, MOSTRO X
{
	initscr();
	noecho();
	start_color();
	curs_set(0);
	cbreak();
	keypad(stdscr,true);
	int exit;
	beginScores();
	exit=welcome();//opzioni schermo + menu
	if(exit!=1)
	{	
	//COLORI
	init_pair(1,COLOR_RED,COLOR_BLACK);
	init_pair(2,COLOR_GREEN,COLOR_BLACK);
	init_pair(3,COLOR_YELLOW,COLOR_BLACK);
	init_pair(6,COLOR_WHITE,COLOR_WHITE);
	init_pair(7,COLOR_BLACK,COLOR_BLACK);
	init_pair(8,COLOR_BLUE,COLOR_BLUE);
	init_pair(9,COLOR_WHITE,COLOR_BLUE);
	init_pair(10,COLOR_BLACK,COLOR_BLUE);
	init_pair(4,COLOR_RED,COLOR_RED);
	init_pair(11,COLOR_RED,COLOR_BLUE);
	init_pair(12,COLOR_WHITE,COLOR_BLACK);
	init_pair(13,COLOR_BLUE,COLOR_BLACK);
	init_pair(14,COLOR_GREEN,COLOR_GREEN);
	init_pair(15,COLOR_CYAN,COLOR_BLACK);
	init_pair(16,COLOR_MAGENTA,COLOR_BLACK);

	//inizializzo le bombe
	Bomb normalBomb;
	Bomb secondBomb;
	BombBlaster bombBlaster;
	tux.addBomb(normalBomb);
	tux.addBomb(secondBomb);
	tux.addBomb(bombBlaster);

	int topX,topY,middX,middY,bottomX,bottomY;
	story();
	Maze::beginControl();//inizializza il labirinto
	Maze::draw();
	//ciclo generale del gioco
			
		
		
		firstLevel(topX,topY,middX,middY,bottomX,bottomY);
		erase();
		
		
		

		if(win)
		{
		win=false;
		secondLevel(topX,topY,middX,middY,bottomX,bottomY);
		
		}
		
		if(win)
		{
		
		win=false;
		erase();
		finalLevel(topX,topY,middX,middY,bottomX,bottomY);
		}
	
		
	
	
	
	
	
	if(!win)
		endOfGame();
	
	}
	endwin();


	
return 0;
}

int welcome()
{
	
	do
	{
		if(COLS<100 || LINES <30 || COLS>100 || LINES >30)
			mvprintw(1,1,"Please resize your screen to 30x100.");
		refresh();
	}
	while(COLS<100 || LINES <30 || COLS>100 || LINES >30);
	mvprintw(1,1,"                                       ");
	refresh();
	box(stdscr,'*','*');

	init_pair(4,COLOR_GREEN,COLOR_BLACK);
	init_pair(1,COLOR_RED,COLOR_BLACK);
	init_pair(5,COLOR_BLUE,COLOR_BLACK);
	init_pair(12,COLOR_WHITE,COLOR_BLACK);
	init_pair(2,COLOR_BLUE,COLOR_WHITE);
	init_pair(3,COLOR_BLACK,COLOR_GREEN);
	init_pair(6,COLOR_CYAN,COLOR_BLACK);

	attron(COLOR_PAIR(6));
	refresh();
	mvprintw (1,12,"888888ba                      dP                           dP  ");
	mvprintw (2,12,"88    `8b                     88                           88                     ");
	mvprintw (3,12,"a88aaaa8P' .d8888b. 88d8b.d8b. 88d888b. .d8888b. 88d888b. d8888P dP    dP dP.  .dP");
	mvprintw (4,12," 88   `8b. 88'  `88 88'`88'`88 88'  `88 88ooood8 88'  `88   88   88    88  `8bd8'");
	mvprintw (5,12,"888    .88 88.  .88 88  88  88 88.  .88 88.  ... 88         88   88.  .88  .d88b.");
	mvprintw (6,12," 88888888P `88888P' dP  dP  dP 88Y8888' `88888P' dP         dP   `88888P' dP'  `dP");
	attron(COLOR_PAIR(1));
	mvprintw (7,12,"   	                . . .");                         
    mvprintw (8,12,"                     \\|/");                        
    mvprintw (9,12,"                   `--+--'");                        
    mvprintw (10,12,"                     /|\\ "); 
    mvprintw (11,12,"                    ' | '");  
    attron(COLOR_PAIR(5));                       
    mvprintw (12,12,"                      |");                           
    mvprintw (13,12,"                      |");                           
    mvprintw (14,12,"                  ,--'#`--.");                       
    mvprintw (15,12,"                  |#######|");                       
    mvprintw (16,12,"               _.-'#######`-._");                    
    mvprintw (17,12,"            ,-'###############`-.");                 
    mvprintw (18,12,"          ,'#####################`,");               
    mvprintw (19,12,"         /#########################\\ ");              
    mvprintw (20,12,"        |###########################| ");            
    mvprintw (21,12,"       |#############################| ");           
    mvprintw (22,12,"       |#############################| ");           
    mvprintw (23,12,"       |#############################|  ");          
    mvprintw (24,12,"       |#############################|  ");          
    mvprintw (25,12,"        |###########################|   ");          
    mvprintw (26,12,"         \\#########################/    ");          
    mvprintw (27,12,"          `.#####################,'     ");          
    mvprintw (28,12,"            `._###############_,'       ");          
    mvprintw (29,12,"               `--..#####..--'      ");







	
	attron(COLOR_PAIR(2));
	
	mvprintw(8,50,"MEMORY MAZE QUEST");
	attron(COLOR_PAIR(12));
	mvprintw (9,50,"BETA VERSION");
	mvprintw (10,50,"Created by Andrea Tucci");
	refresh();
	
	int c;
	unsigned scelta=0;
	
	attron(COLOR_PAIR(1));
	mvprintw(15,80,"-->");
	mvprintw(15,83,"Start Game");
	attron(COLOR_PAIR(12));
	mvprintw(16,83,"How To");
	mvprintw(17,83,"High Score");
	mvprintw(18,83,"Difficulty");
	mvprintw(19,83,"Exit");
	refresh();
	do
	{
	c=getch();
	switch(c)
	{
		case KEY_DOWN:
		scelta=(scelta+1)%5; 
		break;
					
		case KEY_UP:						
		scelta=(scelta-1)%5;
		break;
	}
	switch (scelta)
	{
		case 0:
		attron(COLOR_PAIR(1));
		mvprintw(15,80,"-->");
		mvprintw(15,83,"Start Game");
		attron(COLOR_PAIR(12));
		mvprintw(16,80,"   ");
		mvprintw(16,83,"How To");
		mvprintw(17,80,"   ");
		mvprintw(17,83,"High Score");
		mvprintw(18,80,"   ");
		mvprintw(18,83,"Difficulty");
		mvprintw(19,80,"   ");
		mvprintw(19,83,"Exit");
		break;					

		case 1:						
			attron(COLOR_PAIR(12));
			mvprintw(17,80,"   ");
			mvprintw(17,83,"High Score");
			mvprintw(18,80,"   ");
			mvprintw(18,83,"Difficulty");
			mvprintw(19,80,"   ");
			mvprintw(19,83,"Exit");	
			mvprintw(15,80,"   ");
			mvprintw(15,83,"Start Game");
			attron(COLOR_PAIR(1));
			mvprintw(16,80,"-->");
			mvprintw(16,83,"How To");

			attron(COLOR_PAIR(7));
			mvprintw(17,67,"   ");
			mvprintw(17,70,"    ");
			attron(COLOR_PAIR(12));
			mvprintw(18,70,"    ");
			mvprintw(19,70,"      ");
		break;

		case 2:						
			attron(COLOR_PAIR(12));
			mvprintw(16,80,"   ");
			mvprintw(16,83,"How To");
			mvprintw(18,80,"   ");
			mvprintw(18,83,"Difficulty");
			mvprintw(19,80,"   ");
			mvprintw(19,83,"Exit");
			mvprintw(15,80,"   ");
			mvprintw(15,83,"Start Game");
			attron(COLOR_PAIR(1));
			mvprintw(17,80,"-->");
			mvprintw(17,83,"High Score");

			attron(COLOR_PAIR(7));
			mvprintw(17,67,"   ");
			mvprintw(17,70,"    ");
			attron(COLOR_PAIR(12));
			mvprintw(18,70,"    ");
			mvprintw(19,70,"      ");
		break;
		

		case 3:		
			attron(COLOR_PAIR(12));
			mvprintw(16,80,"   ");
			mvprintw(16,83,"How To");
			mvprintw(17,80,"   ");
			mvprintw(17,83,"High Score");
			mvprintw(19,80,"   ");
			mvprintw(19,83,"Exit");
			mvprintw(15,80,"   ");
			mvprintw(15,83,"Start Game");
			attron(COLOR_PAIR(1));
			mvprintw(18,80,"-->");
			mvprintw(18,83,"Difficulty");
			if(c==' ')
				difficulty();	
			
		break;

		case 4:						
			attron(COLOR_PAIR(12));
			mvprintw(16,80,"   ");
			mvprintw(16,83,"How To");
			mvprintw(17,80,"   ");
			mvprintw(17,83,"High Score");
			mvprintw(18,80,"   ");
			mvprintw(18,83,"Difficulty");
			mvprintw(15,80,"   ");
			mvprintw(15,83,"Start Game");
			attron(COLOR_PAIR(1));
			mvprintw(19,80,"-->");
			mvprintw(19,83,"Exit");	
			attron(COLOR_PAIR(7));
			mvprintw(17,67,"   ");
			mvprintw(17,70,"    ");
			attron(COLOR_PAIR(12));
			mvprintw(18,70,"    ");
			mvprintw(19,70,"      ");
			break;
	}
	refresh();
	}
	while (c!=' ' || scelta %5==3);

	erase();
	if(scelta %5 ==0)
		return 0;
	if(scelta %5==1)
	{
		howTo();
		return 0;
	}
	if(scelta %5==4)
		return 1;
	if(scelta %5==2)
		viewScores();

	return 0;
	
	
}
void endOfGame()
{
	box(stdscr,'x','x');
	init_pair(4,COLOR_GREEN,COLOR_BLACK);
	erase();
	attron(COLOR_PAIR(4));
	refresh();
	
	mvprintw(8,12,"	@@@ @@@  @@@@@@   @@@  @@@      @@@        @@@@@@    @@@@@@   @@@@@@@@");
  	mvprintw(9,12," 	@@@ @@@ @@@@@@@@  @@@  @@@      @@@       @@@@@@@@  @@@@@@@   @@@@@@@@");
  	mvprintw(10,12,"	@@! !@@ @@!  @@@  @@!  @@@      @@!       @@!  @@@  !@@       @@!"); 
   	mvprintw(11,12,"	!@! @!! !@!  @!@  !@!  @!@      !@!       !@!  @!@  !@!       !@!");  
    	mvprintw(12,12,"	 !@!@!  @!@  !@!  @!@  !@!      @!!       @!@  !@!  !!@@!!    @!!!:!"); 
    	mvprintw(13,12,"	  @!!!  !@!  !!!  !@!  !!!      !!!       !@!  !!!   !!@!!!   !!!!!:"); 
    	mvprintw(14,16,"  :!:   !!:  !!!  !!:  !!!      !!:       !!:  !!!       !:!  !!:");  
   	mvprintw(15,16,"  :!:   :!:  !:!  :!:  !:!      :!:      :!:  !:!      !:!    :!:");
    mvprintw(16,16,"  ::    ::::: ::  ::::: ::      :: ::::  ::::: ::  :::: ::    :: ::::");
    mvprintw(17,16,"  :       : :  :    : :  :      : :: : :   : :  :   :: : :    : :: :: ");
    mvprintw (18,12, "( x __ x ) ");
    refresh();
	timeout(3000);
	char s;
	s=getch();
	
	do
	s=getch();
    while(s!=ERR);

}

void story()
{
	attron(COLOR_PAIR(3));
	int c;
	int i=0;
	do
	{
	
	mvprintw(29-i,0,"Long time ago, technology was very important. Human spent all of their time to build new machines.");
	timeout(0);
	c=getch();
	mvprintw(30-i,0,"The years passed and man became more and more skilled, creating robots and machines very powerful.");
	mvprintw(31-i,0,"To do this, man use a lot of memory and he did not care about the huge loss of memory they produced.");

	if(i>6)
	{
	mvprintw(35-i,0,"One day, all the memory lost became real. All the data forgotten by developers joined together.");
	mvprintw(36-i,0,"All human escaped from their home, but it was useless. The enemies began to destroy everything ");
	mvprintw(37-i,0,"and year by year they created a computer-like city. The world was near to total destruction ");
	}
	if(i>12)
	{
	mvprintw(41-i,0,"but there was a robot, forgotten by enemies, that wasn't disabled yet. His name is Bombertux. ");
	mvprintw(42-i,0,"He took the equipment and went to save the world. The Boss of the bad memory, was Malloc who ");
	mvprintw(43-i,0,"lived in a castle...How the story ended? You'll write the ending.");
	}
	sleep(2);
	c=getch();
	move(1,1);
	deleteln();
	refresh();
	i++;
	}
	
	while(c!=' ' && i< 20);

	if(c!=' ')
	{
		mvprintw (29,30,"Press space bar to continue");
		do
			c=getch();
		while(c!= ' ');
	}

	erase();
}

void howTo()
{
	init_pair(2,COLOR_WHITE,COLOR_BLACK);
	init_pair(1,COLOR_RED,COLOR_BLACK);
	init_pair(3,COLOR_BLUE,COLOR_BLACK);
	init_pair(4,COLOR_YELLOW,COLOR_BLACK);
	attron(COLOR_PAIR(2));
	mvprintw(2,0,"In this game you have to kill all monsters to continue, be carefull there are many types of monsters:\n");
	attron(COLOR_PAIR(1));
	mvprintw(3,0,"(o.o)");
	attron(COLOR_PAIR(2));
	mvprintw(3,6,"->> Common monster, when killed you gain 100 $ \n");
	attron(COLOR_PAIR(1));
	mvprintw(4,0,"(O\\./O)");
	attron(COLOR_PAIR(2));
	mvprintw(4,7,"->> Strong monster, when killed you gain 150 $. This monsters can shoot! \n"
			"During the game you can destroy the friable blocks represented in maze as ");
	attron(COLOR_PAIR(4));
	printw("# ");
	attron(COLOR_PAIR(2));
	printw("When you destroy a fria-ble block you can find some power-up: \n");
	attron(COLOR_PAIR(3));
	printw("* ");
	attron(COLOR_PAIR(2));
	printw("->> You can drop 2 bombs.\n");
	attron(COLOR_PAIR(3));
	printw("! ");
	attron(COLOR_PAIR(2));
	printw("->> Increase your bomb's power.\n");
	attron(COLOR_PAIR(3));
	printw("> ");
	attron(COLOR_PAIR(2));
	printw("->> You unlock the Bomb Blaster.\n");
	attron(COLOR_PAIR(3));
	printw("L ");
	attron(COLOR_PAIR(2));
	printw("->> Gain a life.\n");
	attron(COLOR_PAIR(3));
	printw("$ ");
	attron(COLOR_PAIR(2));
	printw("->> You gain 150 $\n");
	printw("To choose your weapon press 'w' and than the correct button. Make a good choice beacause the simple bomb"
	       " is weaker than Bomb Blaster, but it can be dropped anywhere.\nChoose your game style and be carefull from"
	       " monster's attacks, friable blocks can be used as a shi-eld.\nMove Tux with the arrow keys, drop the bombs"
	       " through 'b','n','v' buttons (down,right,left).\nUse the remaning time to obtain more points or break the"
	       " friable blocks to become more powerfull.\nCan you complete the Memory Maze Quest?\n");
	attron(COLOR_PAIR(4));
	printw("Press 'tab' to menu");
	char c;
	do
	c=getch();
	while(c!=' ');
	erase();
	welcome();
	
	
}

void firstLevel(int& topX,int& topY,int& middX,int& middY,int& bottomX,int& bottomY)
{

		
	stat.setTime(200);
	//lista di mostri
	list<Monster*> monsters;

		CommonMonster enemy;
		CommonMonster enemy2;
		CommonMonster enemy3;
		CommonMonster enemy4;

		StrongMonster strongEnemy;
		StrongMonster strongEnemy2;
		StrongMonster strongEnemy3;
		StrongMonster strongEnemy4;
		StrongMonster strongEnemy5;
	//dichiaro i mostri del livello
	if(diff==0)
	{
		//riempio la lista
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);
		monsters.push_back(&strongEnemy);
	}
	if(diff==1)
	{
		//riempio la lista
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);
		monsters.push_back(&enemy4);

		monsters.push_back(&strongEnemy);
		monsters.push_back(&strongEnemy2);
		monsters.push_back(&strongEnemy3);

		
	}

	if(diff==2)
	{
		//riempio la lista
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);
		monsters.push_back(&enemy4);

		monsters.push_back(&strongEnemy);
		monsters.push_back(&strongEnemy2);
		monsters.push_back(&strongEnemy3);
		monsters.push_back(&strongEnemy4);
		monsters.push_back(&strongEnemy5);

		
	}
	
	//segno la vita iniziale
	currLife=tux.getLife();
	//disegno i mostri
	for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
		(*it)->draw();
	//finestre PRIMO LIVELLO
	WINDOW* level=newwin (5,40,15,30);
	wbkgd(level,COLOR_PAIR(16));
	box(level,'1','1');
	refresh();
	mvwprintw(level,2,11,"LEVEL 1");
	PANEL* level1=new_panel(level);
	update_panels();
	doupdate();
	timeout(2000);
	getch();
	del_panel(level1);
	delwin(level);
do
{

	topX=middX=bottomX=1;
	topY=10;
	middY=11;
	bottomY=12;
	attron(COLOR_PAIR(1));
	mvprintw(topY,topX," _\\_ ");
	attron(COLOR_PAIR(12));
	mvprintw(middY,middX,"(| |)");
	attron(COLOR_PAIR(1));
	mvprintw(bottomY,bottomX,"  ^  ");
	for(int i=10;i<13;i++)
		for(int j=1;j<6;j++)
			Maze::control[i][j]='T';
	refresh();
	
	do
	{
			
		usleep(20000);
		tempoAttuale=time(0);
		//visualizza la vita, i punti e il tempo
		stat.view(tux);
		tux.moveTux(topX,topY,middX,middY,bottomX,bottomY,tempoAttuale,currLife);
		//tux.checkLife(topY,topX);
		
		for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
		{

			if((*it)->checkLife()==false)
				(*it)->killed();
					
			if((*it)->isDead())
			{
				monsters.erase(it);
				Stats::setPoints(Stats::getPoints()+100);
			}
			else
			{
				if((*it)->isStrong() && rand()% 80 == 0)
					(*it)->shoot(tempoAttuale);
					if((*it)->isStrong() && (*it)->hasShooted())
					(*it)->moveShoot();
				if(rand()% (*it)->getVelocity() == 0 )
					(*it)->moveMonster();
				
			}
		}//for dei mostri
			
		refresh();
			
		/*
			for(int i=0;i<30;i++)
		for(int j=0;j<100;j++)
			mvaddch(i,j,Maze::control[i][j]);	
			refresh();
		*/	
		
		
	}
	while(currLife == tux.getLife() && monsters.size()>0);

		
		if(monsters.size() <=0)
		{
			win=true;
			WINDOW* end=newwin (10,30,15,40);
			wbkgd(end,COLOR_PAIR(16));
			box(end,'!','!');
			mvwprintw(end,3,2,"SUCCESS!!LEVEL COMPLETED.");
			PANEL* panel=new_panel(end);
			update_panels();
			doupdate();
			stat.timeToPoints(tux);
			mvwprintw(end,5,9,"PRESS 'C' KEY");
			update_panels();
			doupdate();
			char c;
			do
				c=getch();
			while(c!='c');
			del_panel(panel);
			delwin(end);
				
		}
		else
		{
			currLife=tux.getLife();
			for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
			{
				(*it)->reDraw((*it)->getY());
				if( (*it)->isStrong() && (*it)->hasShooted() )
					(*it)->delShoot();
			}
			
		}
		

	}
	while(!stat.isGameOver() && win==false );

	if(stat.isGameOver() && !win)
		endOfGame();
	
	
	return;
		
}
void secondLevel(int& topX,int& topY,int& middX,int& middY,int& bottomX,int& bottomY)
{

	Maze::beginControl();//inizializza il labirinto
	Maze::draw();
	list<Monster*> monsters;
	CommonMonster enemy;
	CommonMonster enemy2;
	CommonMonster enemy3;
	CommonMonster enemy4;
	CommonMonster enemy5;

	StrongMonster strongEnemy;
	StrongMonster strongEnemy2;
	StrongMonster strongEnemy3;
	StrongMonster strongEnemy4;
	StrongMonster strongEnemy5;
	StrongMonster strongEnemy6;
	StrongMonster strongEnemy7;
	StrongMonster strongEnemy8;
	StrongMonster strongEnemy9;
	StrongMonster strongEnemy10;

	stat.setTime(200);

	if(diff==0)
	{
	
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);

		monsters.push_back(&strongEnemy);
		monsters.push_back(&strongEnemy2);
		monsters.push_back(&strongEnemy3);
		monsters.push_back(&strongEnemy4);
	}

	if(diff==1)
	{
		
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);
		monsters.push_back(&enemy4);
		monsters.push_back(&enemy5);
		

		monsters.push_back(&strongEnemy);
		monsters.push_back(&strongEnemy2);
		monsters.push_back(&strongEnemy3);
		monsters.push_back(&strongEnemy4);
		monsters.push_back(&strongEnemy5);
	}

	if(diff==2)
	{
	
		monsters.push_back(&enemy);
		monsters.push_back(&enemy2);
		monsters.push_back(&enemy3);
		monsters.push_back(&enemy4);
		monsters.push_back(&enemy5);
		

		monsters.push_back(&strongEnemy);
		monsters.push_back(&strongEnemy2);
		monsters.push_back(&strongEnemy3);
		monsters.push_back(&strongEnemy4);
		monsters.push_back(&strongEnemy5);
		monsters.push_back(&strongEnemy6);
		monsters.push_back(&strongEnemy7);
		monsters.push_back(&strongEnemy8);
		monsters.push_back(&strongEnemy9);
		monsters.push_back(&strongEnemy10);
	}


	currLife=tux.getLife();

	for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
		(*it)->draw();

	WINDOW* level=newwin (5,40,15,30);
	wbkgd(level,COLOR_PAIR(16));
	box(level,'2','2');
	refresh();
	mvwprintw(level,2,11,"LEVEL 2");
	PANEL* level2=new_panel(level);
	update_panels();
	doupdate();
	timeout(2000);
	getch();
	del_panel(level2);
	delwin(level);
	
do
{
	topX=middX=bottomX=1;
	topY=10;
	middY=11;
	bottomY=12;
	attron(COLOR_PAIR(1));
	mvprintw(topY,topX," _\\_ ");
	attron(COLOR_PAIR(12));
	mvprintw(middY,middX,"(| |)");
	attron(COLOR_PAIR(1));
	mvprintw(bottomY,bottomX,"  ^  ");
	for(int i=10;i<13;i++)
		for(int j=1;j<6;j++)
			Maze::control[i][j]='T';
	do
	{
			
		usleep(20000);
		tempoAttuale=time(0);
		//visualizza la vita, i punti e il tempo
		stat.view(tux);
		//controlla se tux è stato colpito
		tux.moveTux(topX,topY,middX,middY,bottomX,bottomY,tempoAttuale,currLife);
			
		for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
		{

			if((*it)->checkLife()==false)
				(*it)->killed();
					
			if((*it)->isDead())
			{
				monsters.erase(it);
				if((*it)->isStrong())
					Stats::setPoints(Stats::getPoints()+150);
				else
					Stats::setPoints(Stats::getPoints()+100);
				
			}
			else
			{
				if((*it)->isStrong() && rand()% 80 == 0)
					(*it)->shoot(tempoAttuale);
					if((*it)->isStrong() && (*it)->hasShooted())
					(*it)->moveShoot();
				if(rand()% (*it)->getVelocity() == 0 )
					(*it)->moveMonster();
				
				
			}
			}
			
		
			
		
		/*	for(int i=0;i<53;i++)
		for(int j=0;j<178;j++)
			mvaddch(i,j,Maze::control[i][j]);	
			refresh();
		*/
		
		
	}
	while(currLife == tux.getLife() && monsters.size()>0);

		
		if(monsters.size() <=0)
		{
			WINDOW* end=newwin (10,30,15,40);
			wbkgd(end,COLOR_PAIR(15));
			box(end,'!','!');
			mvwprintw(end,3,2,"SUCCESS!!LEVEL COMPLETED.");
			PANEL* panel=new_panel(end);
			update_panels();
			doupdate();
			stat.timeToPoints(tux);
			mvwprintw(end,5,9,"PRESS 'C' KEY");
			update_panels();
			doupdate();
			char c;
			do
				c=getch();
			while(c!='c');
			del_panel(panel);
			delwin(end);
				
		}
		else
		{
			currLife=tux.getLife();
			for(list<Monster*>::iterator it=monsters.begin();it!=monsters.end();it++)
			{
				(*it)->reDraw((*it)->getY());
				if( (*it)->isStrong() && (*it)->hasShooted())
					(*it)->delShoot();
			}
		}
		

	}
	while(!stat.isGameOver() && win==false );
	if(stat.isGameOver())
		endOfGame();

	return;
	
}

void finalLevel(int& topX,int& topY,int& middX,int& middY,int& bottomX,int& bottomY)
{
	Boss finalBoss;
	Maze::beginControl();
	finalBoss.draw();
	Maze::drawForBoss();

	bool hasSpoken=false;
	stat.setTime(300);
	stat.setBoss(true);
	
	WINDOW* level=newwin (5,40,15,30);
	wbkgd(level,COLOR_PAIR(16));
	box(level,'x','x');
	refresh();
	mvwprintw(level,2,11,"FINAL LEVEL");
	PANEL* finalLevel=new_panel(level);
	update_panels();
	doupdate();
	timeout(2000);
	getch();
	del_panel(finalLevel);
	delwin(level);

	topX=middX=bottomX=1;
	topY=10;
	middY=11;
	bottomY=12;
	attron(COLOR_PAIR(1));
	mvprintw(topY,topX," _\\_ ");
	attron(COLOR_PAIR(12));
	mvprintw(middY,middX,"(| |)");
	attron(COLOR_PAIR(1));
	mvprintw(bottomY,bottomX,"  ^  ");
	
	for(int i=10;i<13;i++)
		for(int j=1;j<6;j++)
			Maze::control[i][j]='T';

	dialogue();

do
{
	topX=middX=bottomX=1;
	topY=10;
	middY=11;
	bottomY=12;
	attron(COLOR_PAIR(1));
	mvprintw(topY,topX," _\\_ ");
	attron(COLOR_PAIR(12));
	mvprintw(middY,middX,"(| |)");
	attron(COLOR_PAIR(1));
	mvprintw(bottomY,bottomX,"  ^  ");
	for(int i=10;i<13;i++)
		for(int j=1;j<6;j++)
			Maze::control[i][j]='T';
	
	do
	{
			
		usleep(20000);
		
		tempoAttuale=time(0);
		//visualizza la vita, i punti e il tempo
		stat.view(tux);
		//controlla se tux è stato colpito
		tux.moveTux(topX,topY,middX,middY,bottomX,bottomY,tempoAttuale,currLife);
		
		if(finalBoss.checkLife()==false)
		{
			Boss::decrementLife();
			finalBoss.reDraw();
		}
		
		if(Boss::getLife()<=0)
			finalBoss.setDeath(true);
		
		if(Boss::getLife() <=10 && !hasSpoken)
		{
			finalPart();
			hasSpoken=true;
		}
			
			
			
		
		if(rand() % 20==0)
			finalBoss.moveMonster();
		
		if(rand() % 40==0 && finalBoss.hasShooted()==false)
			finalBoss.shoot(tempoAttuale);
		if(finalBoss.hasShooted())
			finalBoss.moveShoot();

		
		
		
		
		/*
		for(int i=0;i<30;i++)
			for(int j=0;j<100;j++)
				mvaddch(i,j,Maze::control[i][j]);	
		
			refresh();
		*/
		
		
		
	}
	while(currLife == tux.getLife() && finalBoss.isDead()==false);
	
	if(currLife!=tux.getLife())
	{
		currLife=tux.getLife();
		finalBoss.delShoot();
	}

}
while(!stat.isGameOver() && finalBoss.isDead()==false);
	
	if(stat.isGameOver())
		endOfGame();

	if(finalBoss.isDead())

		scores(stat);
		


}

void dialogue()
{
	int c;
	WINDOW* dial=newwin(10,40,15,30);
	wbkgd(dial,COLOR_PAIR(1));
	box(dial,'*','*');
	refresh();
	mvwprintw(dial,2,1,"Malloc: \n");
	PANEL* dialog=new_panel(dial);
	mvwprintw(dial,2,1,"Congratulations..You have destroyed");
	mvwprintw(dial,3,1,"my army. But this is nothing...");
	wbkgd(dial,COLOR_PAIR(3));
	mvwprintw(dial,9,9,"Press SPACE to continue");
	update_panels();
	doupdate();

	
	do
	c=getch();
	while(c!=' ');
	
	wbkgd(dial,COLOR_PAIR(1));
	mvwprintw(dial,2,1,"From years man continue to use data in");
	mvwprintw(dial,3,1,"a bad way.it's time to make a change!");
	wbkgd(dial,COLOR_PAIR(3));
	mvwprintw(dial,9,9,"Press SPACE to continue");
	update_panels();
	doupdate();
	do
	c=getch();
	while(c!=' ');
	wbkgd(dial,COLOR_PAIR(1));
	mvwprintw(dial,2,1,"You are a foolish! All man race need  ");
	mvwprintw(dial,3,1,"to be destroyed!Com'on Bombertux,    ");
	mvwprintw(dial,4,1, "I start with you!!");
	wbkgd(dial,COLOR_PAIR(3));
	mvwprintw(dial,9,9,"Press SPACE to continue");
	update_panels();
	doupdate();
	do
	c=getch();
	while(c!=' ');

	
	del_panel(dialog);
	delwin(dial);
	
	return;

	

}

void difficulty()
{

	unsigned miniScelta=0;
	int x;
	attron(COLOR_PAIR(1));
	mvprintw(17,67,"-->");
	mvprintw(17,70,"Easy");
	attron(COLOR_PAIR(12));
	mvprintw(18,67,"   ");
	mvprintw(19,67,"   ");
	mvprintw(18,70,"Hard");
	mvprintw(19,70,"Insane");

			
		do
		{	
			x=getch();
			switch(x)
			{
				case KEY_DOWN:	
							miniScelta=(miniScelta+1)%3;
							break;
				case KEY_UP:
							miniScelta=(miniScelta-1)%3;
							break;
			}
			switch(miniScelta)
			{
				case 1:
						attron(COLOR_PAIR(1));
						mvprintw(18,67,"-->");
						mvprintw(18,70,"Hard");
						attron(COLOR_PAIR(12));
						mvprintw(17,67,"   ");
						mvprintw(19,67,"   ");
						mvprintw(17,70,"Easy");
						mvprintw(19,70,"Insane");
						break;
				case 2:
						attron(COLOR_PAIR(1));
						mvprintw(19,67,"-->");
						mvprintw(19,70,"Insane");
						attron(COLOR_PAIR(12));
						mvprintw(17,67,"   ");
						mvprintw(18,67,"   ");
						mvprintw(17,70,"Easy");
						mvprintw(18,70,"Hard");
						break;
				case 0:
						attron(COLOR_PAIR(1));
						mvprintw(17,67,"-->");
						mvprintw(17,70,"Easy");
						attron(COLOR_PAIR(12));
						mvprintw(18,67,"   ");
						mvprintw(19,67,"   ");
						mvprintw(18,70,"Hard");
						mvprintw(19,70,"Insane");
						break;
								
								

					}			

			}while(x!=' ');
		if(miniScelta %3 ==0)
			diff=0;
		if(miniScelta %3 ==1)
			diff=1;
		if(miniScelta %3 ==2)
			diff=2;

		mvprintw(17,67,"   ");
		mvprintw(18,67,"   ");
		mvprintw(19,67,"   ");

		mvprintw(17,70,"    ");
		mvprintw(18,70,"    ");
		mvprintw(19,70,"      ");

		
}
void finalPart()
{
	
	WINDOW* dialx=newwin(10,40,15,30);
	box(dialx,'*','*');
	wbkgd(dialx,COLOR_PAIR(3));
	mvwprintw(dialx,2,1,"Malloc: \n");
	PANEL* dialogx=new_panel(dialx);
	mvwprintw(dialx,3,1,"You...Can't beat me!");
	mvwprintw(dialx,4,1,"Stupid blocks..Take this!");
	mvwprintw(dialx,5,1,"MEMORY LEAK!");
	update_panels();
	doupdate();
	sleep(2);
	del_panel(dialogx);
	delwin(dialx);
	Maze::delBlocks();

	
	
	
}

void scores(Stats stat)
{
	
	WINDOW* dialy=newwin(10,40,15,30);
	box(dialy,'*','*');
	wbkgd(dialy,COLOR_PAIR(3));
	mvwprintw(dialy,2,1,"Malloc: \n");
	PANEL* dialogy=new_panel(dialy);
	mvwprintw(dialy,3,1,"Noooo...it can't be...");
	mvwprintw(dialy,4,1,"it CAN'T BEEE");
	update_panels();
	doupdate();

	for(int i=0;i<10;i++)
	{
		
		bkgd(COLOR_PAIR(6));
		if(i>=2)
			usleep(200000);
		else
		
		if(i>=5)
			usleep(100000);
		else
			sleep(1);
		update_panels();
		doupdate();
		bkgd(COLOR_PAIR(7));
		if(i>=2)
			usleep(200000);
		else

		if(i>=5)
			usleep(100000);
		else
			sleep(1);
		update_panels();
		doupdate();
	
	}
	del_panel(dialogy);
	delwin(dialy);

	erase();

	attron(COLOR_PAIR(3));
	mvprintw(0,0,"Now the world is safe. All is back to normality and the bad data was deleted. Thanks Bombertux!");
	mvprintw(1,20,"( ^    ^ )");

	mvprintw(10,10,"YOU COMPLETED THE GAME! WRITE YOUR NAME HERE (PRESS SPACE TO FINISH)\n");

	echo();
	
	string nameOfFile;
	switch(diff)
	{
		case 0: nameOfFile="highScoresEasy.txt";
				break;
		case 1: nameOfFile="highScoresHard.txt";
				break;
		case 2: nameOfFile="highScoresInsane.txt";
				break;
	}
	
	ofstream out(nameOfFile.data(),ios::app);
	ios::ate;
	
	gamer winner;
	
	char c;
	winner.points=stat.getPoints();
	
	int i=0;//conta i caratteri immessi
	

	do
	{
		c=getch();
		if(c!=ERR && c!=' ')
		{
			winner.name[i]=c;
			i++;
		}
		
	}
	while(c!=' ' && i<=30);
	
	winner.name[i]='\0';
	
	out.seekp( (winner.points)* sizeof(gamer) );
	out.write( reinterpret_cast<const char *> (&winner), sizeof(gamer) );

	
	out.close();
	
	viewScores();
	
	noecho();
	
	win=true;
	
}

void viewScores()
{
	erase();
	
	init_pair(1,COLOR_CYAN,COLOR_BLACK);
	init_pair(2,COLOR_RED,COLOR_BLACK);
	init_pair(3,COLOR_GREEN,COLOR_BLACK);
	init_pair(4,COLOR_BLACK,COLOR_BLACK);
	init_pair(5,COLOR_WHITE,COLOR_BLACK);
	init_pair(6,COLOR_YELLOW,COLOR_BLACK);
		
	attron(COLOR_PAIR(1));
	mvprintw(0,3,"	 _   _            _         ___ ");                                  
	mvprintw(1,3,"	( ) ( ) _        ( )       (  _`\\ ");                                
	mvprintw(2,3,"	| |_| |(_)   __  | |__     | (_(_)   ___    _    _ __   __    ___ ");
	mvprintw(3,3,"	|  _  || | /'_ `\\|  _ `\\   `\\__ \\  /'___) /'_`\\ ( '__)/'__`\\/',__)");
	mvprintw(4,3,"	| | | || |( (_) || | | |   ( )_) |( (___ ( (_) )| |  (  ___/\\__, \\");
	mvprintw(5,3,"	(_) (_)(_)`\\__  |(_) (_)   `\\____)`\\____)`\\___/'(_)  `\\____)(____/");
	mvprintw(6,3,"	          ( )_) | ");                                                
	mvprintw(7,3,"    		   \\___/' ");                                                

	ifstream in;

	gamer winner;
	int i=0;
	
	in.open("highScoresEasy.txt");
	attron(COLOR_PAIR(2));

	mvprintw(9,0,"NAME");
	mvprintw(9,30,"POINTS");
	int c;
	
	attron(COLOR_PAIR(4));
	mvprintw (29,0,"             ");
	attron(COLOR_PAIR(1));
	mvprintw(29,80,"Hard Mode ->>");
	mvprintw(8,0,"EASY MODE");
	
	
	int choose=0;
	do
	{	
		c=getch();
		switch(c)
		{
			case KEY_RIGHT:
					choose=(choose+1)%3;
					break;
			case KEY_LEFT:
					choose=(choose-1)%3;
					break;
		}
	
		switch(choose)
		{
			case 0: 
				in.close();
				in.open("highScoresEasy.txt");
				in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				attron(COLOR_PAIR(6));
				i=0;
				while( in && !in.eof())
				{
					if(winner.points !=0 )
					{
						mvprintw(9+i,30,"%d",winner.points);
						mvprintw(9+i,0,winner.name);
						i++;
					}
					
					in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				}
				
				attron(COLOR_PAIR(4));
				mvprintw (29,0,"             ");
				attron(COLOR_PAIR(1));
				mvprintw(29,80,"Hard Mode ->>");
				mvprintw(8,0,"EASY MODE  ");
				break;
		
			case 1:
				in.close();
				in.open("highScoreHard.txt");
				
				in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				i=0;
				attron(COLOR_PAIR(6));

				while( in && !in.eof())
				{
					if(winner.points !=0 )
					{
						mvprintw(9+i,30,"%d",winner.points);
						mvprintw(9+i,0,winner.name);
						i++;
					}
					
					in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				}
				attron(COLOR_PAIR(3));
				mvprintw(29,0,"<<- Easy Mode");
				mvprintw(29,80,"Insane Mode ->>  ");
				mvprintw(8,0,"HARD MODE  ");
				break;
			case 2:
				in.close();
				in.open("highScoreInsane.txt");
				in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				i=0;
				attron(COLOR_PAIR(6));

				while( in && !in.eof())
				{
					if(winner.points !=0 )
					{
						mvprintw(9+i,30,"%d",winner.points);
						mvprintw(9+i,0,winner.name);
						i++;
					}
					
					in.read(reinterpret_cast<char *> (&winner), sizeof(gamer) );
				}
				attron(COLOR_PAIR(4));
				mvprintw(29,80,"            ");
				attron(COLOR_PAIR(5));
				mvprintw(29,0,"<<- Hard Mode");
				mvprintw(8,0,"InSaNe MODE");
				break;
		}
		refresh();
		
	}
	while(c!=' ');

	in.close();
	
	
}

void beginScores()
{
	ofstream out;
	ifstream test("highScoresEasy.txt");
	
	
	if(!test.is_open() )
	{
		out.open("highScoresEasy.txt",ios::out);
	
		gamer gamerx = {0,""};
		for(int i=0;i<30;i++)
			out.write (reinterpret_cast<const char *>(&gamerx), sizeof(gamer) );
		out.close();
		
		out.open("highScoresHard.txt",ios::out);
		for(int i=0;i<30;i++)
			out.write (reinterpret_cast<const char *>(&gamerx), sizeof(gamer) );
		out.close();
		
		out.open("highScoresInsane.txt",ios::out);
		for(int i=0;i<30;i++)
			out.write (reinterpret_cast<const char *>(&gamerx), sizeof(gamer) );
		out.close();
		
		
	}
	test.close();
	
}
